<?php
namespace TrxEffects\Core\Api;

use TrxEffects\Plugin;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

class Elementor {


	/**
	 * Class constructor.
	 *
	 * Initializing modules manager.
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function __construct() {
	}

	/**
	 * Check if plugin Elementor is active
	 *
	 * Return true if a plugin Elementor is installed and activated
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function exists() {
		return class_exists('Elementor\Plugin');
	}


	/**
	 * Check if Elementor is in the preview mode
	 *
	 * Return true if Elementor is in the preview mode
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function is_preview() {
		static $is_preview = -1;
		if ( $is_preview === -1 ) {
			$is_preview = $this->exists() 
							&& (\Elementor\Plugin::instance()->preview->is_preview_mode()
								|| Plugin::instance()->html->get_value_gp( 'elementor-preview' ) > 0
								|| ( Plugin::instance()->html->get_value_gp( 'post' ) > 0
									&& Plugin::instance()->html->get_value_gp( 'action' ) == 'elementor'
									)
								|| ( is_admin()
									&& in_array( Plugin::instance()->html->get_value_gp( 'action' ), array( 'elementor', 'elementor_ajax', 'wp_ajax_elementor_ajax' ) )
									)
								);
		}
		return $is_preview;
	}


	/**
	 * Check if Elementor is in the edit mode
	 *
	 * Return true if Elementor is in the edit mode
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function is_edit_mode() {
		static $is_edit_mode = -1;
		if ( $is_edit_mode === -1 ) {
			$is_edit_mode = $this->exists()
								&& ( \Elementor\Plugin::instance()->editor->is_edit_mode()
									|| ( Plugin::instance()->html->get_value_gp( 'post' ) > 0
										&& Plugin::instance()->html->get_value_gp( 'action' ) == 'elementor'
										)
									|| ( is_admin()
										&& in_array( Plugin::instance()->html->get_value_gp( 'action' ), array( 'elementor', 'elementor_ajax', 'wp_ajax_elementor_ajax' ) )
										)
									);
		}
		return $is_edit_mode;
	}
}
