<?php
namespace TrxEffects\Core\Modules\ImageMask;

use TrxEffects\Plugin;
use TrxEffects\Core\Modules\Module;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

class ImageMask extends Module {

	/**
	 * Elementor API object.
	 *
	 * Holds the object with Elementor API.
	 *
	 * @since 1.0.0
	 * @access public
	 *
	 * @var elementor
	 */
	public $elementor;


	/**
	 * Class constructor.
	 *
	 * Initializing module.
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function __construct() {
		add_action( 'trx_effects_action/load', array( $this, 'load' ), 20 );	// Need priority greater then 10 ( each next level of 'load' must be greater then caller class )
	}

	/**
	 * Load modules
	 *
	 * Create instance of modules
	 *
	 * @hook action 'trx_effects_action/load'
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function load() {
		parent::load();
		$this->elementor = new ImageMaskElementor();
	}

}
