<?php
namespace TrxEffects\Core\Options;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * An option field of the type 'date'
 *
 * Add a date to the options page
 *
 * @since 1.0.0
 */
class CustomizerFieldDate extends CustomizerFieldText {

	/**
	 * Display an inner layout of the field.
	 *
	 * Display tags inside field's wrapper.
	 *
	 * @param (string) name - a name of the field
	 * @param (array) field - an array with field description
	 *
	 * @return (string) output - a string with a html layout of the field
	 *
	 * @since 1.0.0
	 * @access protected
	 */
	protected function show_field_layout( $id, $name, $field ) {
		$field['data'] = array(
			'format' => ! empty( $field['format'] ) ? $field['format'] : 'yy-mm-dd',
			'months' => ! empty( $field['months'] ) ? $field['months'] : 1
		);
		if ( ! empty( $field['mask'] ) ) {
			$field['data']['mask'] = $field['mask'];
		}
		return parent::show_field_layout( $id, $name, $field );
	}

}
