<?php
namespace TrxEffects\Core\Options;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * An option field of the type 'switch'
 *
 * Add a switch control (two radio buttons) to the options page
 *
 * @since 1.0.0
 */
class CustomizerFieldSwitch extends CustomizerFieldRadio {

	/**
	 * Display an inner layout of the field.
	 *
	 * Display tags inside field's wrapper.
	 *
	 * @param (string) name - a name of the field
	 * @param (array) field - an array with field description
	 *
	 * @return (string) output - a string with a html layout of the field
	 *
	 * @since 1.0.0
	 * @access protected
	 */
	protected function show_field_layout( $id, $name, $field ) {
		$field['options'] = array(
			1 => esc_html__( 'Yes', 'trx-effects' ),
			0 => esc_html__( 'No', 'trx-effects' ),
		);
		return parent::show_field_layout( $id, $name, $field );
	}
}
