<?php
/**
 * Plugin Name: Visual Effects & Animation Kit for Elementor
 * Description: Add custom visual effects to Elementor's core modules
 * Plugin URI: https://persianscript.ir
 * Author: پرشین اسکریپت
 * Version: 1.0.5
 * Author URI: https://persianscript.ir
 *
 * Text Domain: trx-effects
 * Domain Path: /languages/
 *
 * @package ThemeREX Effects
 * @category Core
 *
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

define( 'TRX_EFFECTS_FILE', __FILE__ );
define( 'TRX_EFFECTS_BASE', plugin_basename( TRX_EFFECTS_FILE ) );
define( 'TRX_EFFECTS_DIR', plugin_dir_path( TRX_EFFECTS_FILE ) );
define( 'TRX_EFFECTS_URL', plugins_url( '/', TRX_EFFECTS_FILE ) );

define( 'TRX_EFFECTS_CORE', 'core/' );
define( 'TRX_EFFECTS_MODULES', TRX_EFFECTS_CORE . 'modules/' );

add_action( 'plugins_loaded', 'trx_effects_load_plugin_textdomain' );

require_once TRX_EFFECTS_DIR . 'includes/utils.php';

require_once TRX_EFFECTS_DIR . 'core/plugin.php';

/**
 * Load textdomain.
 *
 * Load gettext translate for a plugin's text domain.
 *
 * @since 1.0.0
 *
 * @return void
 */
function trx_effects_load_plugin_textdomain() {
	static $loaded = false;
	if ( $loaded ) return true;
	$domain = 'trx-effects';
	if ( is_textdomain_loaded( $domain ) && ! is_a( $GLOBALS['l10n'][ $domain ], 'NOOP_Translations' ) ) return true;
	$loaded = true;
	load_plugin_textdomain( $domain, false, dirname( TRX_EFFECTS_BASE ) . '/languages' );
}

/**
 * Return a name of the plugin.
 *
 * Return a name of the plugin.
 *
 * @since 1.0.0
 *
 * @return void
 */
function trx_effects_get_plugin_name() {
	return esc_html__( 'ThemeREX Effects', 'trx-effects' );
}
